Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 1 | # =========================================================================== |
| 2 | # Kernel configuration targets |
| 3 | # These targets are used from top-level makefile |
| 4 | |
Michal Marek | 1cba0c3 | 2015-04-08 11:11:57 +0200 | [diff] [blame] | 5 | PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \ |
Steven Rostedt | 281c9da | 2009-04-29 22:52:23 -0400 | [diff] [blame] | 6 | localmodconfig localyesconfig |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 7 | |
Al Viro | 61bee20 | 2008-08-25 04:51:27 -0400 | [diff] [blame] | 8 | ifdef KBUILD_KCONFIG |
| 9 | Kconfig := $(KBUILD_KCONFIG) |
| 10 | else |
Arnaud Lacombe | 838a2e5 | 2010-09-04 17:10:20 -0400 | [diff] [blame] | 11 | Kconfig := Kconfig |
Al Viro | 61bee20 | 2008-08-25 04:51:27 -0400 | [diff] [blame] | 12 | endif |
Sam Ravnborg | e703f75 | 2007-10-25 20:42:18 +0200 | [diff] [blame] | 13 | |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 14 | ifeq ($(quiet),silent_) |
| 15 | silent := -s |
| 16 | endif |
| 17 | |
Yann E. MORIN | c2838e6 | 2012-11-22 01:06:04 +0100 | [diff] [blame] | 18 | # We need this, in case the user has it in its environment |
| 19 | unexport CONFIG_ |
| 20 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 21 | xconfig: $(obj)/qconf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 22 | $< $(silent) $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 23 | |
| 24 | gconfig: $(obj)/gconf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 25 | $< $(silent) $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 26 | |
| 27 | menuconfig: $(obj)/mconf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 28 | $< $(silent) $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 29 | |
| 30 | config: $(obj)/conf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 31 | $< $(silent) --oldaskconfig $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 32 | |
nir.tzachar@gmail.com | 692d97c | 2009-11-25 12:28:43 +0200 | [diff] [blame] | 33 | nconfig: $(obj)/nconf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 34 | $< $(silent) $(Kconfig) |
nir.tzachar@gmail.com | 692d97c | 2009-11-25 12:28:43 +0200 | [diff] [blame] | 35 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 36 | silentoldconfig: $(obj)/conf |
Masahiro Yamada | 9815594 | 2014-05-29 14:33:03 +0900 | [diff] [blame] | 37 | $(Q)mkdir -p include/config include/generated |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 38 | $< $(silent) --$@ $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 39 | |
Arnaud Lacombe | 50bce3e | 2011-07-01 18:13:03 -0400 | [diff] [blame] | 40 | localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf |
Masahiro Yamada | 9815594 | 2014-05-29 14:33:03 +0900 | [diff] [blame] | 41 | $(Q)mkdir -p include/config include/generated |
Arnaud Lacombe | 22d550a | 2011-07-20 00:40:09 -0400 | [diff] [blame] | 42 | $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config |
Michal Marek | 7a996d3 | 2010-08-04 14:05:07 +0200 | [diff] [blame] | 43 | $(Q)if [ -f .config ]; then \ |
Sam Ravnborg | 4062f1a | 2010-07-31 23:35:26 +0200 | [diff] [blame] | 44 | cmp -s .tmp.config .config || \ |
| 45 | (mv -f .config .config.old.1; \ |
| 46 | mv -f .tmp.config .config; \ |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 47 | $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \ |
Sam Ravnborg | 4062f1a | 2010-07-31 23:35:26 +0200 | [diff] [blame] | 48 | mv -f .config.old.1 .config.old) \ |
| 49 | else \ |
| 50 | mv -f .tmp.config .config; \ |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 51 | $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \ |
Steven Rostedt | a7c0260 | 2009-05-07 11:09:55 -0400 | [diff] [blame] | 52 | fi |
Steven Rostedt | 03fa25d | 2009-04-29 22:52:22 -0400 | [diff] [blame] | 53 | $(Q)rm -f .tmp.config |
| 54 | |
EGRY Gabor | 1020026 | 2008-01-11 23:40:00 +0100 | [diff] [blame] | 55 | # Create new linux.pot file |
Sam Ravnborg | b70e325c | 2007-06-10 20:38:27 +0200 | [diff] [blame] | 56 | # Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files |
EGRY Gabor | 46d2631 | 2008-01-11 23:46:11 +0100 | [diff] [blame] | 57 | update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 58 | $(Q)$(kecho) " GEN config.pot" |
Peter Foley | a24a1b8 | 2011-04-26 18:13:05 -0400 | [diff] [blame] | 59 | $(Q)xgettext --default-domain=linux \ |
| 60 | --add-comments --keyword=_ --keyword=N_ \ |
| 61 | --from-code=UTF-8 \ |
| 62 | --files-from=$(srctree)/scripts/kconfig/POTFILES.in \ |
| 63 | --directory=$(srctree) --directory=$(objtree) \ |
Sam Ravnborg | b70e325c | 2007-06-10 20:38:27 +0200 | [diff] [blame] | 64 | --output $(obj)/config.pot |
| 65 | $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot |
Paul Bolle | fa0ad657 | 2011-11-05 12:21:30 +0100 | [diff] [blame] | 66 | $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \ |
| 67 | $(srctree)/arch/*/um/Kconfig`; \ |
EGRY Gabor | 1020026 | 2008-01-11 23:40:00 +0100 | [diff] [blame] | 68 | do \ |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 69 | $(kecho) " GEN $$i"; \ |
Sam Ravnborg | 4217516 | 2008-04-25 21:15:41 +0200 | [diff] [blame] | 70 | $(obj)/kxgettext $$i \ |
EGRY Gabor | 1020026 | 2008-01-11 23:40:00 +0100 | [diff] [blame] | 71 | >> $(obj)/config.pot; \ |
| 72 | done ) |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 73 | $(Q)$(kecho) " GEN linux.pot" |
EGRY Gabor | 1020026 | 2008-01-11 23:40:00 +0100 | [diff] [blame] | 74 | $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \ |
Sam Ravnborg | b70e325c | 2007-06-10 20:38:27 +0200 | [diff] [blame] | 75 | --output $(obj)/linux.pot |
Sam Ravnborg | b70e325c | 2007-06-10 20:38:27 +0200 | [diff] [blame] | 76 | $(Q)rm -f $(obj)/config.pot |
Arnaldo Carvalho de Melo | 3b9fa09 | 2005-05-05 15:09:46 -0700 | [diff] [blame] | 77 | |
Michal Marek | 1cba0c3 | 2015-04-08 11:11:57 +0200 | [diff] [blame] | 78 | # These targets map 1:1 to the commandline options of 'conf' |
| 79 | simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \ |
| 80 | alldefconfig randconfig listnewconfig olddefconfig |
| 81 | PHONY += $(simple-targets) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 82 | |
Michal Marek | 1cba0c3 | 2015-04-08 11:11:57 +0200 | [diff] [blame] | 83 | $(simple-targets): $(obj)/conf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 84 | $< $(silent) --$@ $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 85 | |
Michal Marek | 1cba0c3 | 2015-04-08 11:11:57 +0200 | [diff] [blame] | 86 | PHONY += oldnoconfig savedefconfig defconfig |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 87 | |
Adam Lee | fb16d89 | 2012-09-01 01:05:17 +0800 | [diff] [blame] | 88 | # oldnoconfig is an alias of olddefconfig, because people already are dependent |
| 89 | # on its behavior(sets new symbols to their default value but not 'n') with the |
| 90 | # counter-intuitive name. |
Michal Marek | 1cba0c3 | 2015-04-08 11:11:57 +0200 | [diff] [blame] | 91 | oldnoconfig: olddefconfig |
Adam Lee | fb16d89 | 2012-09-01 01:05:17 +0800 | [diff] [blame] | 92 | |
Sam Ravnborg | 7cf3d73 | 2010-07-31 23:35:34 +0200 | [diff] [blame] | 93 | savedefconfig: $(obj)/conf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 94 | $< $(silent) --$@=defconfig $(Kconfig) |
Sam Ravnborg | 7cf3d73 | 2010-07-31 23:35:34 +0200 | [diff] [blame] | 95 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 96 | defconfig: $(obj)/conf |
| 97 | ifeq ($(KBUILD_DEFCONFIG),) |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 98 | $< $(silent) --defconfig $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 99 | else |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 100 | @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'" |
| 101 | $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 102 | endif |
| 103 | |
| 104 | %_defconfig: $(obj)/conf |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 105 | $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 106 | |
Masahiro Yamada | 63a9103 | 2015-03-13 15:21:43 +0900 | [diff] [blame] | 107 | configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@) |
Josh Triplett | 3aaefce | 2014-08-06 15:21:00 -0700 | [diff] [blame] | 108 | |
Masahiro Yamada | 63a9103 | 2015-03-13 15:21:43 +0900 | [diff] [blame] | 109 | %.config: $(obj)/conf |
| 110 | $(if $(call configfiles),, $(error No configuration exists for this target on this architecture)) |
| 111 | $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles) |
| 112 | +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig |
Josh Triplett | 3aaefce | 2014-08-06 15:21:00 -0700 | [diff] [blame] | 113 | |
| 114 | PHONY += kvmconfig |
Masahiro Yamada | 63a9103 | 2015-03-13 15:21:43 +0900 | [diff] [blame] | 115 | kvmconfig: kvm_guest.config |
| 116 | @: |
Josh Triplett | 3aaefce | 2014-08-06 15:21:00 -0700 | [diff] [blame] | 117 | |
Josh Triplett | 0da1d4a | 2014-08-08 16:25:47 -0700 | [diff] [blame] | 118 | PHONY += tinyconfig |
Masahiro Yamada | 63a9103 | 2015-03-13 15:21:43 +0900 | [diff] [blame] | 119 | tinyconfig: |
| 120 | $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config |
Josh Triplett | 0da1d4a | 2014-08-08 16:25:47 -0700 | [diff] [blame] | 121 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 122 | # Help text used by make help |
| 123 | help: |
| 124 | @echo ' config - Update current config utilising a line-oriented program' |
nir.tzachar@gmail.com | 692d97c | 2009-11-25 12:28:43 +0200 | [diff] [blame] | 125 | @echo ' nconfig - Update current config utilising a ncurses menu based program' |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 126 | @echo ' menuconfig - Update current config utilising a menu based program' |
Diego Viola | 092373c | 2015-04-06 06:27:45 -0300 | [diff] [blame^] | 127 | @echo ' xconfig - Update current config utilising a Qt based front-end' |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 128 | @echo ' gconfig - Update current config utilising a GTK based front-end' |
| 129 | @echo ' oldconfig - Update current config utilising a provided .config as base' |
Steven Rostedt | 03fa25d | 2009-04-29 22:52:22 -0400 | [diff] [blame] | 130 | @echo ' localmodconfig - Update current config disabling modules not loaded' |
Steven Rostedt | 281c9da | 2009-04-29 22:52:23 -0400 | [diff] [blame] | 131 | @echo ' localyesconfig - Update current config converting local mods to core' |
Markus Heidelberg | 590a585 | 2009-05-18 01:36:46 +0200 | [diff] [blame] | 132 | @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps' |
Sam Ravnborg | 0748cb3 | 2010-07-31 23:35:31 +0200 | [diff] [blame] | 133 | @echo ' defconfig - New config with default from ARCH supplied defconfig' |
Sam Ravnborg | 7cf3d73 | 2010-07-31 23:35:34 +0200 | [diff] [blame] | 134 | @echo ' savedefconfig - Save current config as ./defconfig (minimal config)' |
Jesper Juhl | e11f049 | 2006-02-25 21:52:50 +0100 | [diff] [blame] | 135 | @echo ' allnoconfig - New config where all options are answered with no' |
Sam Ravnborg | 0748cb3 | 2010-07-31 23:35:31 +0200 | [diff] [blame] | 136 | @echo ' allyesconfig - New config where all options are accepted with yes' |
| 137 | @echo ' allmodconfig - New config selecting modules when possible' |
| 138 | @echo ' alldefconfig - New config with all symbols set to default' |
| 139 | @echo ' randconfig - New config with random answer to all options' |
Sam Ravnborg | 861b4ea | 2010-07-31 23:35:28 +0200 | [diff] [blame] | 140 | @echo ' listnewconfig - List new options' |
Adam Lee | fb16d89 | 2012-09-01 01:05:17 +0800 | [diff] [blame] | 141 | @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their default value' |
Josh Triplett | 3aaefce | 2014-08-06 15:21:00 -0700 | [diff] [blame] | 142 | @echo ' kvmconfig - Enable additional options for guest kernel support' |
Josh Triplett | 0da1d4a | 2014-08-08 16:25:47 -0700 | [diff] [blame] | 143 | @echo ' tinyconfig - Configure the tiniest possible kernel' |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 144 | |
Sam Ravnborg | 2982de6 | 2006-07-27 22:10:27 +0200 | [diff] [blame] | 145 | # lxdialog stuff |
| 146 | check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh |
| 147 | |
Rob Landley | e9e40e1 | 2007-10-15 19:23:12 -0500 | [diff] [blame] | 148 | # Use recursively expanded variables so we do not call gcc unless |
Sam Ravnborg | 2982de6 | 2006-07-27 22:10:27 +0200 | [diff] [blame] | 149 | # we really need to do so. (Do not call gcc as part of make mrproper) |
Arnaud Lacombe | 9ba9568 | 2010-08-22 20:03:06 -0400 | [diff] [blame] | 150 | HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \ |
| 151 | -DLOCALE |
Sam Ravnborg | 2982de6 | 2006-07-27 22:10:27 +0200 | [diff] [blame] | 152 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 153 | # =========================================================================== |
| 154 | # Shared Makefile for the various kconfig executables: |
| 155 | # conf: Used for defconfig, oldconfig and related targets |
nir.tzachar@gmail.com | 692d97c | 2009-11-25 12:28:43 +0200 | [diff] [blame] | 156 | # nconf: Used for the nconfig target. |
| 157 | # Utilizes ncurses |
Markus Heidelberg | 6f26e5e | 2009-05-18 01:36:45 +0200 | [diff] [blame] | 158 | # mconf: Used for the menuconfig target |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 159 | # Utilizes the lxdialog package |
| 160 | # qconf: Used for the xconfig target |
Diego Viola | 092373c | 2015-04-06 06:27:45 -0300 | [diff] [blame^] | 161 | # Based on Qt which needs to be installed to compile it |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 162 | # gconf: Used for the gconfig target |
| 163 | # Based on GTK which needs to be installed to compile it |
| 164 | # object files used by all kconfig flavours |
| 165 | |
Sam Ravnborg | 2982de6 | 2006-07-27 22:10:27 +0200 | [diff] [blame] | 166 | lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o |
| 167 | lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o |
| 168 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 169 | conf-objs := conf.o zconf.tab.o |
nir.tzachar@gmail.com | 692d97c | 2009-11-25 12:28:43 +0200 | [diff] [blame] | 170 | mconf-objs := mconf.o zconf.tab.o $(lxdialog) |
| 171 | nconf-objs := nconf.o zconf.tab.o nconf.gui.o |
Arnaldo Carvalho de Melo | 3b9fa09 | 2005-05-05 15:09:46 -0700 | [diff] [blame] | 172 | kxgettext-objs := kxgettext.o zconf.tab.o |
Peter Foley | f194304 | 2011-04-26 18:00:05 -0400 | [diff] [blame] | 173 | qconf-cxxobjs := qconf.o |
Arnaud Lacombe | 5a6f8d2 | 2011-06-01 16:14:47 -0400 | [diff] [blame] | 174 | qconf-objs := zconf.tab.o |
| 175 | gconf-objs := gconf.o zconf.tab.o |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 176 | |
Masahiro Yamada | 022af62 | 2014-08-19 16:34:22 +0900 | [diff] [blame] | 177 | hostprogs-y := conf nconf mconf kxgettext qconf gconf |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 178 | |
Arnaud Lacombe | 5a6f8d2 | 2011-06-01 16:14:47 -0400 | [diff] [blame] | 179 | clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck |
Arnaud Lacombe | 2f76b35 | 2011-05-23 01:08:19 -0400 | [diff] [blame] | 180 | clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h |
EGRY Gabor | 1020026 | 2008-01-11 23:40:00 +0100 | [diff] [blame] | 181 | clean-files += config.pot linux.pot |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 182 | |
Sam Ravnborg | 6e588f6 | 2007-12-09 20:11:15 +0100 | [diff] [blame] | 183 | # Check that we have the required ncurses stuff installed for lxdialog (menuconfig) |
| 184 | PHONY += $(obj)/dochecklxdialog |
| 185 | $(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog |
| 186 | $(obj)/dochecklxdialog: |
Arnaud Lacombe | 7080e47 | 2010-08-16 00:19:04 -0400 | [diff] [blame] | 187 | $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf) |
Sam Ravnborg | 6e588f6 | 2007-12-09 20:11:15 +0100 | [diff] [blame] | 188 | |
| 189 | always := dochecklxdialog |
| 190 | |
Sam Ravnborg | aa1e5ef | 2007-08-12 23:15:44 +0200 | [diff] [blame] | 191 | # Add environment specific flags |
| 192 | HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS)) |
Yuri Vasilevski | 70a6a0c | 2005-10-30 15:03:20 -0800 | [diff] [blame] | 193 | |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 194 | # generated files seem to need this to find local include files |
Arnaud Lacombe | 2f76b35 | 2011-05-23 01:08:19 -0400 | [diff] [blame] | 195 | HOSTCFLAGS_zconf.lex.o := -I$(src) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 196 | HOSTCFLAGS_zconf.tab.o := -I$(src) |
| 197 | |
Arnaud Lacombe | 378dbb2 | 2011-05-23 02:08:52 -0400 | [diff] [blame] | 198 | LEX_PREFIX_zconf := zconf |
| 199 | YACC_PREFIX_zconf := zconf |
| 200 | |
Arnaud Lacombe | 5a6f8d2 | 2011-06-01 16:14:47 -0400 | [diff] [blame] | 201 | HOSTLOADLIBES_qconf = $(KC_QT_LIBS) |
| 202 | HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 203 | |
Arnaud Lacombe | 5a6f8d2 | 2011-06-01 16:14:47 -0400 | [diff] [blame] | 204 | HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0` |
Adrian Bunk | 3719314 | 2006-01-02 11:25:30 +0100 | [diff] [blame] | 205 | HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \ |
Arnaud Lacombe | 1ea3ad4 | 2011-06-05 23:36:05 -0400 | [diff] [blame] | 206 | -Wno-missing-prototypes |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 207 | |
Arnaud Lacombe | 7080e47 | 2010-08-16 00:19:04 -0400 | [diff] [blame] | 208 | HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC)) |
| 209 | |
Justin Lecher | 544e7e5 | 2013-03-06 14:02:02 +0100 | [diff] [blame] | 210 | HOSTLOADLIBES_nconf = $(shell \ |
Brian Norris | 7285996 | 2014-06-04 00:52:31 -0700 | [diff] [blame] | 211 | pkg-config --libs menuw panelw ncursesw 2>/dev/null \ |
| 212 | || pkg-config --libs menu panel ncurses 2>/dev/null \ |
Justin Lecher | 544e7e5 | 2013-03-06 14:02:02 +0100 | [diff] [blame] | 213 | || echo "-lmenu -lpanel -lncurses" ) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 214 | $(obj)/qconf.o: $(obj)/.tmp_qtcheck |
| 215 | |
Masahiro Yamada | 022af62 | 2014-08-19 16:34:22 +0900 | [diff] [blame] | 216 | ifeq ($(MAKECMDGOALS),xconfig) |
Roman Zippel | b3a5225 | 2005-11-21 21:32:38 -0800 | [diff] [blame] | 217 | $(obj)/.tmp_qtcheck: $(src)/Makefile |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 218 | -include $(obj)/.tmp_qtcheck |
| 219 | |
Diego Viola | 092373c | 2015-04-06 06:27:45 -0300 | [diff] [blame^] | 220 | # Qt needs some extra effort... |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 221 | $(obj)/.tmp_qtcheck: |
Michal Marek | 0a1f00a | 2015-04-08 13:30:42 +0200 | [diff] [blame] | 222 | @set -e; $(kecho) " CHECK qt"; dir=""; pkg=""; \ |
Alexander Stein | 133c5f7 | 2010-08-31 17:34:37 +0200 | [diff] [blame] | 223 | if ! pkg-config --exists QtCore 2> /dev/null; then \ |
Diego Viola | 092373c | 2015-04-06 06:27:45 -0300 | [diff] [blame^] | 224 | echo "* Unable to find the Qt4 tool qmake. Trying to use Qt3"; \ |
Alexander Stein | 133c5f7 | 2010-08-31 17:34:37 +0200 | [diff] [blame] | 225 | pkg-config --exists qt 2> /dev/null && pkg=qt; \ |
| 226 | pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \ |
| 227 | if [ -n "$$pkg" ]; then \ |
| 228 | cflags="\$$(shell pkg-config $$pkg --cflags)"; \ |
| 229 | libs="\$$(shell pkg-config $$pkg --libs)"; \ |
| 230 | moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \ |
| 231 | dir="$$(pkg-config $$pkg --variable=prefix)"; \ |
| 232 | else \ |
| 233 | for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \ |
| 234 | if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \ |
| 235 | done; \ |
| 236 | if [ -z "$$dir" ]; then \ |
Michal Marek | 5b580fa | 2012-07-07 23:32:18 +0200 | [diff] [blame] | 237 | echo >&2 "*"; \ |
Diego Viola | 092373c | 2015-04-06 06:27:45 -0300 | [diff] [blame^] | 238 | echo >&2 "* Unable to find any Qt installation. Please make sure that"; \ |
| 239 | echo >&2 "* the Qt4 or Qt3 development package is correctly installed and"; \ |
Michal Marek | 5b580fa | 2012-07-07 23:32:18 +0200 | [diff] [blame] | 240 | echo >&2 "* either qmake can be found or install pkg-config or set"; \ |
| 241 | echo >&2 "* the QTDIR environment variable to the correct location."; \ |
| 242 | echo >&2 "*"; \ |
Alexander Stein | 133c5f7 | 2010-08-31 17:34:37 +0200 | [diff] [blame] | 243 | false; \ |
| 244 | fi; \ |
| 245 | libpath=$$dir/lib; lib=qt; osdir=""; \ |
| 246 | $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \ |
| 247 | osdir=x$$($(HOSTCXX) -print-multi-os-directory); \ |
| 248 | test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \ |
| 249 | test -f $$libpath/libqt-mt.so && lib=qt-mt; \ |
| 250 | cflags="-I$$dir/include"; \ |
| 251 | libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \ |
| 252 | moc="$$dir/bin/moc"; \ |
| 253 | fi; \ |
| 254 | if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \ |
| 255 | echo "*"; \ |
| 256 | echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \ |
| 257 | echo "*"; \ |
| 258 | moc="/usr/bin/moc"; \ |
| 259 | fi; \ |
Sam Ravnborg | ab919c0 | 2005-11-06 11:05:21 +0100 | [diff] [blame] | 260 | else \ |
Michal Marek | 458452f | 2010-09-13 13:41:31 +0200 | [diff] [blame] | 261 | cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \ |
| 262 | libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \ |
Yaakov Selkowitz | 4848594 | 2012-07-04 15:23:29 -0500 | [diff] [blame] | 263 | moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \ |
| 264 | [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \ |
Roman Zippel | b3a5225 | 2005-11-21 21:32:38 -0800 | [diff] [blame] | 265 | fi; \ |
| 266 | echo "KC_QT_CFLAGS=$$cflags" > $@; \ |
| 267 | echo "KC_QT_LIBS=$$libs" >> $@; \ |
| 268 | echo "KC_QT_MOC=$$moc" >> $@ |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 269 | endif |
| 270 | |
| 271 | $(obj)/gconf.o: $(obj)/.tmp_gtkcheck |
| 272 | |
Masahiro Yamada | 022af62 | 2014-08-19 16:34:22 +0900 | [diff] [blame] | 273 | ifeq ($(MAKECMDGOALS),gconfig) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 274 | -include $(obj)/.tmp_gtkcheck |
| 275 | |
| 276 | # GTK needs some extra effort, too... |
| 277 | $(obj)/.tmp_gtkcheck: |
Adrian Bunk | 3719314 | 2006-01-02 11:25:30 +0100 | [diff] [blame] | 278 | @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \ |
| 279 | if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \ |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 280 | touch $@; \ |
| 281 | else \ |
Michal Marek | 5b580fa | 2012-07-07 23:32:18 +0200 | [diff] [blame] | 282 | echo >&2 "*"; \ |
| 283 | echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \ |
| 284 | echo >&2 "*"; \ |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 285 | false; \ |
| 286 | fi \ |
| 287 | else \ |
Michal Marek | 5b580fa | 2012-07-07 23:32:18 +0200 | [diff] [blame] | 288 | echo >&2 "*"; \ |
| 289 | echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \ |
| 290 | echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \ |
| 291 | echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \ |
| 292 | echo >&2 "*"; \ |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 293 | false; \ |
| 294 | fi |
| 295 | endif |
| 296 | |
Arnaud Lacombe | 2f76b35 | 2011-05-23 01:08:19 -0400 | [diff] [blame] | 297 | $(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 298 | |
Arnaud Lacombe | 5a6f8d2 | 2011-06-01 16:14:47 -0400 | [diff] [blame] | 299 | $(obj)/qconf.o: $(obj)/qconf.moc |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 300 | |
Yaakov Selkowitz | ebca026 | 2012-07-04 18:31:11 -0500 | [diff] [blame] | 301 | quiet_cmd_moc = MOC $@ |
| 302 | cmd_moc = $(KC_QT_MOC) -i $< -o $@ |
| 303 | |
| 304 | $(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck |
| 305 | $(call cmd,moc) |
Linus Torvalds | 1da177e | 2005-04-16 15:20:36 -0700 | [diff] [blame] | 306 | |
EGRY Gabor | 46d2631 | 2008-01-11 23:46:11 +0100 | [diff] [blame] | 307 | # Extract gconf menu items for I18N support |
| 308 | $(obj)/gconf.glade.h: $(obj)/gconf.glade |
Peter Foley | 2d80eb0 | 2011-04-26 18:16:53 -0400 | [diff] [blame] | 309 | $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \ |
Peter Foley | a24a1b8 | 2011-04-26 18:13:05 -0400 | [diff] [blame] | 310 | $(obj)/gconf.glade |